#!/bin/bash
#
# (c) astx (at) aws-it.at, 2018 - 2019
# and (c) others - see DIYaudio thread https://www.diyaudio.com/forums/software-tools/331656-installing-using-ngspice-opensource-simulator.html
#
# $Id: step_opamp_devices.sh 1579 2019-01-17 11:34:34Z sta $
#
echo ""; echo ""
echo "#-----------------------------------------------------------------------"
echo "NOTE: For successful run you need at least ngspice 30 using the attached"
echo "unofficial patches:"
echo "    astx_ngspice_linearize_allow_custom_time_range.diff"
echo "    astx_ngspice_write_ignore_currents.diff"
echo "After simulation run you can further explore the result data"
echo "Use 'quit' to exit simulation"
echo ""
echo "#-----------------------------------------------------------------------"
echo "If you want to run opamp stepping simulation now enter 'y' <ENTER>"
echo "#-----------------------------------------------------------------------"

read a
if [ "$a" == "y" ]; then

	# change this to your preferred editor. vi nano joe ...
	export SPICE_EDITOR="joe"

	# temporary net list file
	mynet="gain_preamp-1.net"


	chead="\n.control\n"
	cend="\n.endc\n"

	echo -en "${chead}" > load_result_files0.inc
	echo -en "${chead}" > load_result_files1.inc
	echo -en "${chead}" > load_result_files2.inc

	tranplots=''
	count=1
	for opamp in NE5532 NE5534-15P AD797-CMP AD8672 OP1177
	do
		
		opamp=$(echo $opamp|tr 'A-Z' 'a-z')
		# load schematic and create a fresh netlist
		gnetlist -g spice-sdb -o $mynet gain_preamp.sch
		# replace %MYOPA% from schematic by $opamp
		sed -i -r -e "s/\%MYOPA\%/${opamp}/g" $mynet
		echo -en "\n.options savecurrents\n.control\n\tset opamp=\"${opamp}\"\n\techo \"OPA \$opamp\"\n.endc\n\n" > $mynet.inc
		ngspice -i $mynet.inc $mynet

		# generate load result files listing
		echo "load ngspice_tran_${opamp}.data" >> load_result_files1.inc
		echo "load ngspice_vars_${opamp}.data" >> load_result_files2.inc
		tranplots="${tranplots}tran${count} "
		count=$(($count+1))
	done

	echo -en "${cend}" >> load_result_files1.inc
	echo -en "${cend}" >> load_result_files2.inc
	echo -en "set tranplots=( ${tranplots})${cend}" >> load_result_files0.inc

	# load (no netlist!) results only from stepping and display e.g. fft, fourier and input, output voltages
	ngspice opamp_calc_results.ngspice

	# reset terminal if ngspice terminates unexpectedly
	reset
fi
